import {
  world,
  Player,
  system
} from "@minecraft/server";

//Ledge Climb
system.runInterval(() => {
  for (const player of  world.getPlayers({
    scoreOptions: [
      {objective: "botBlock", maxScore: 1, minScore: 1},
      {objective: "topBlock", maxScore: 1, minScore: 1},
      {objective: "headBlock", maxScore: 1, minScore: 1},
      {objective: "offGround", maxScore: 1, minScore: 1},
      {objective: "ledgeBlock", maxScore: 1, minScore: 1},
      {objective: "ledgeClimb", maxScore: 0, minScore: 0},
      {objective: "fenceBlock", maxScore: 0, minScore: 0}
    ],

    }))
  {

  const tickDelay = 4

      if (player.isValid() && player.isJumping && !player.isOnGround) {
        system.runTimeout(() =>{
          
          player.runCommand('function climb_ledge');
          player.runCommand('event entity @s mcac:climb_ledge');
  
          system.runTimeout(() =>{

          player.applyKnockback(player.getViewDirection().x,player.getViewDirection().z, 0, 0.7);
          player.runCommand('scoreboard players set @s botBlock 0');
          player.runCommand('scoreboard players set @s ledgeClimb 1');

          system.runTimeout(() =>{

            player.applyKnockback(player.getViewDirection().x,player.getViewDirection().z, 0.3, 0.1);
        
          }, 5);
      
        }, tickDelay);
  
      }, 0);

      }
  }
});

//Fence Vault
system.runInterval(() => {
  for (const player of  world.getPlayers({
    scoreOptions: [
      {objective: "fenceBlock", maxScore: 1, minScore: 1},
      {objective: "feetFenceBlock", maxScore: 0, minScore: 0},
      {objective: "lowFenceClear", maxScore: 1, minScore: 1},
      {objective: "topFenceClear", maxScore: 1, minScore: 1},
      {objective: "frontFenceClear", maxScore: 1, minScore: 1}
    ],

    }))
  {


      if (player.isValid() && player.isJumping) {
        system.runTimeout(() =>{
          
          player.runCommand('function fence_vault');
          player.runCommand('event entity @s mcac:fence_vault');
  
          system.runTimeout(() =>{

          player.runCommand('tp @s ^ ^ ^0.6');
          player.runCommand('scoreboard players set @s fenceBlock 0');

          system.runTimeout(() =>{

            player.applyKnockback(player.getViewDirection().x,player.getViewDirection().z, 0.8, 0.2);
        
          }, 2);
      
        }, 2);
  
      }, 0);

      }
  }
});

//Bar Swing
system.runInterval(() => {
  for (const player of  world.getPlayers({
    scoreOptions: [
      {objective: "barHandle", maxScore: 1, minScore: 1},
      {objective: "barPathChest", maxScore: 1, minScore: 1},
      {objective: "barPathFrontHead", maxScore: 1, minScore: 1},
      {objective: "barPathFrontChest", maxScore: 1, minScore: 1}
    ],

    }))
  {


      if (player.isValid() && player.isJumping && !player.isOnGround) {
        system.runTimeout(() =>{
          
          player.runCommand('function bar_swing');
          player.runCommand('playanimation @s bar_swing1');
  
          system.runTimeout(() =>{

          player.runCommand('tp @s ^ ^ ^0.5');

          system.runTimeout(() =>{

            player.applyKnockback(player.getViewDirection().x,player.getViewDirection().z, 0.9, 0.2);

            system.runTimeout(() =>{

              player.applyKnockback(player.getViewDirection().x,player.getViewDirection().z, 0.3, 0.2);
          
            }, 3);
        
          }, 3);
      
        }, 2);
  
      }, 0);

      }
  }
});